/*
STARS 2.0: same program as STARS 1.0 but written with hpgcc 2.0
  for the arm-based calculators.
*/

#include <hpstdlib.h>
#include <hpkeyb49.h>
#include <hpmath.h>
#include <hpgraphics.h>

int main(void)
{
	#define WIDTH 131
    #define HEIGHT 80
	#define MAX_STARS 130
	
	#define MODULO 200
	#define MOINS MODULO/2	
	#define ZZ 100
	
	#define ROT 0.05

	unsigned char old_ticks = sys_setRTCTickPeriod(1); 
	hpg_set_mode_mono(1);
    srand(0);
	
	int bgx[256];
	int bgy[256];
	
	int i;
	for (i=0; i<256; i++)
        {	
			bgx[i] = rand() % 131; 
			bgy[i] = rand() % 80;
		}

	int starx[MAX_STARS];
	int stary[MAX_STARS];  
	int starz[MAX_STARS];  
	 
	int d=32; 
	int cx = WIDTH/2;
	int cy = HEIGHT/2;
	int speed = 4;
	int sx,sy,sw;
	int sxx,syy;
	
	double rot = ROT; 
	int flag = 0;
	
	for (i=0; i<MAX_STARS; i++)
    {
      starx[i]= (rand() % MODULO) - MOINS;
      stary[i]= (rand() % MODULO) - MOINS;
	  starz[i]= (rand() % 50) + ZZ;
	}	
	
	for(;;)
	{
		hpg_set_color(hpg_stdscreen,HPG_COLOR_BLACK);
		hpg_fill_rect(0,0,130,79);
		hpg_set_color(hpg_stdscreen,HPG_COLOR_WHITE);
		
		sys_slowOff();
		
		for (i=0; i<256; i++)
        {	
			hpg_draw_pixel(bgx[i],bgy[i]);
		}
		
		for (i=0; i<MAX_STARS; i++)
        {			
			if (starz[i] < speed/2)
			{ 
				starx[i]= (rand() % MODULO) - MOINS;
				stary[i]= (rand() % MODULO) - MOINS;
				starz[i]= (rand() % 50) + ZZ;
			}
			
			starz[i] -= speed; 
			sx = ( starx[i] * d ) / (starz[i]); 
			sy = ( stary[i] * d ) / (starz[i]); 
			
			sxx = (sx * cos(rot)) - (sy * sin(rot));
			syy = (sx * sin(rot)) + (sy * cos(rot));
			
			sxx = sxx + cx;
			syy = cy - syy;
			
			if( sxx <= 0 || sxx >= WIDTH  || syy <= 0 || syy >= HEIGHT ) 
			{ 
				starx[i]= (rand() % MODULO) - MOINS;
				stary[i]= (rand() % MODULO) - MOINS;
				starz[i]= (rand() % 50) + ZZ;
			}
			else
			{
				sw=1;
				if(starz[i] < 85) sw=2;
				if(starz[i] < 55) sw=3;
				if(starz[i] < 25) sw=4;
				
				hpg_fill_rect(sxx,syy,sxx+sw,syy+sw);
			}
		}
		
		if(flag == 0) rot += ROT;
		if(rot > 3.0) flag = 1;
		if(flag == 1)
		{
			if(rot > -3.0) rot -= ROT; 
			else flag = 0; 
		}
		
		sys_slowOn();
		hpg_flip();
		sys_waitRTCTicks(3);
		if (keyb_isON()) break;
	}
	sys_setRTCTickPeriod(old_ticks); 
    return 0;	
}
